/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################



///#######################################################################
///
///#######################################################################

typedef float										_ss_block;
typedef	float __declspec(align(16)) 				_ps_block[4];

typedef long										_ss_long;
typedef	long __declspec(align(16))					_ps_long[4];




//#define PS_CVAR_PS1(name, val)			const __m128 name = { (val), (val), (val), (val) };		///float types. An ANSI C compiler takes the two expressions, LONG_VAR and CHAR_VAR, and implicitly casts them to the type of the first member of the union
//#define PS_CVARI_PS1(name, val)			const __m128i name = { (val), (val), (val), (val) };		///http://www.keil.com/support/docs/135.htm: there is no mechanism in C to specify which one to initialize
//#define PS_CVARI_PS1(name, val)		    const _ps_long BOOST_PP_CAT(name, ___ps_long) = { (val), (val), (val), (val) }; const __m128i &name = TO_M128I(BOOST_PP_CAT(name, ___ps_long));		 ///http://www.keil.com/support/docs/135.htm: there is no mechanism in C to specify which one to initialize




/// TODO: see also http://216.239.59.104/search?q=cache:HmsQIU-m2toJ:www2.technobabble.com.au/article280.html+athlon+64+float+units&hl=en&ct=clnk&cd=22
/// SSE3 -> x87 floating point to integer conversion (fisttp)
 



///#######################################################################
///
///#######################################################################


#if ENABLE_SSE_VECTOR

	#define IF_ENABLE_SSE_VECTOR(yes, no)		REMOVE_PARENTHESES(yes)
	#define IF_ENABLE_SSE_VECTOR1(yes)			REMOVE_PARENTHESES(yes)
	#define ENABLED_SSE_ALIGN					SSE_ALIGN
	#define ENABLED_SSE_ALIGN_VAL				SSE_ALIGN_VAL
	
#else

	#define IF_ENABLE_SSE_VECTOR(yes, no)		REMOVE_PARENTHESES(no)
	#define IF_ENABLE_SSE_VECTOR1(yes)			
	#define ENABLED_SSE_ALIGN					
	#define ENABLED_SSE_ALIGN_VAL				4	

#endif	
	



#define SSE_ALIGN_VAL				16
#define SSE_ALIGN					__declspec(align(16))
#define SSE_ALIGN_FARG				///__declspec(align(16))
#define SSE_TALIGN_CHECK(T)			BOOST_STATIC_ASSERT((alignment_of<T>::value % SSE_ALIGN_VAL) == 0);
//#define SSE_VALIGN_CHECK(V)			BOOST_STATIC_ASSERT(((void *)(&V)) % SSE_ALIGN_VAL == 0);
//#define SSE_VALIGN_CHECK(V)			BOOST_STATIC_ASSERT(__alignof(V) >= SSE_ALIGN_VAL);
//#define SSE_VALIGN_CHECK(V)			BOOST_STATIC_ASSERT((alignof(V) % SSE_ALIGN_VAL) == 0);
#define SSE_VALIGN_CHECK(V)


///#######################################################################
///
///#######################################################################

//DISABLE_WARNING(4700)		///warning C4700: uninitialized local variable 'af' used


#ifdef MACROS_CPP


	#define CUSTOM_MM_OP1(name, ftype, ltype, ctype, loadstore_ref, ...)		\
																				\
	/*inline */__m128 PP_CAT3(_mm_, name, ctype)(const __m128 &a_in)				\
	{																			\
		ftype af, rvalf;														\
		ltype &a		= *(ltype *)(&af);									    \
		ltype &rvalb	= *(ltype *)(&rvalf);								    \
																				\
		BOOST_PP_CAT(_mm_store, ctype)(loadstore_ref af, a_in);					\
																				\
		__VA_ARGS__;															\
																				\
		return BOOST_PP_CAT(_mm_load, ctype)(loadstore_ref rvalf);			    \
	};																			\


	#define CUSTOM_MM_OP2(name, ftype, ltype, ctype, loadstore_ref, ...)		\
																				\
	/*inline */__m128 PP_CAT3(_mm_, name, ctype)(const __m128 &a_in, const __m128 &b_in)	\
	{																			\
		ftype af, bf, rvalf;													\
		ltype &a		= *(ltype *)(&af);										\
		ltype &b		= *(ltype *)(&bf);										\
		ltype &rvalb	= *(ltype *)(&rvalf);									\
																				\
		BOOST_PP_CAT(_mm_store, ctype)(loadstore_ref af, a_in);					\
		BOOST_PP_CAT(_mm_store, ctype)(loadstore_ref bf, b_in);					\
																				\
		__VA_ARGS__;															\
																				\
		return BOOST_PP_CAT(_mm_load, ctype)(loadstore_ref rvalf);			    \
	};	
	
	
	#define CUSTOM_SS_OP1(name, ...)										CUSTOM_MM_OP1(name, _ss_block, _ss_long, _ss, &, __VA_ARGS__)
	#define CUSTOM_SS_OP2(name, ...)										CUSTOM_MM_OP2(name, _ss_block, _ss_long, _ss, &, __VA_ARGS__)
	
	#define CUSTOM_PS_OP1(name, ...)										CUSTOM_MM_OP1(name, _ps_block, _ps_long, _ps, , __VA_ARGS__)
	#define CUSTOM_PS_OP2(name, ...)										CUSTOM_MM_OP2(name, _ps_block, _ps_long, _ps, , __VA_ARGS__)


#else


	#define CUSTOM_SS_OP1(name, ...)											\
	__m128 PP_CAT3(_mm_, name, _ss)(const __m128 &a_in);						\

	#define CUSTOM_SS_OP2(name, ...)											\
	__m128 PP_CAT3(_mm_, name, _ss)(const __m128 &a_in, const __m128 &b_in);	\


	#define CUSTOM_PS_OP1(name, ...)											\
	__m128 PP_CAT3(_mm_, name, _ps)(const __m128 &a_in);						\

	#define CUSTOM_PS_OP2(name, ...)											\
	__m128 PP_CAT3(_mm_, name, _ps)(const __m128 &a_in, const __m128 &b_in);	\



#endif



DISABLE_WARNING(4189)	///warning C4189: 'rvalb' : local variable is initialized but not referenced


	CUSTOM_SS_OP2(and,		rvalb = a & b)
	CUSTOM_SS_OP2(or,		rvalb = a | b)
	CUSTOM_SS_OP2(andnot,	rvalb = ~a & b)
	CUSTOM_SS_OP2(xor,		rvalb = a ^ b)

	
	///#######################################################################


	CUSTOM_SS_OP2(set,		_mm_store_ss(&rvalf, _mm_load_ss(&bf)))						///note that high bits get here copied too
	CUSTOM_PS_OP2(set,		_mm_store_ps(&rvalf[0], _mm_load_ps(&bf[0])))					///simply rvalb = b did not compile here for some reason


	///#######################################################################


	CUSTOM_SS_OP1(abs,		rvalf = fabsf(af))			   ///we use simple absf because SSE version requires using _mm_and_ss which uses also simple registers
	/*CUSTOM_SS_OP1											
	(
		abs,		
		
		long const bmask = 0x7FFFFFFF;	
		float &fmask = *(float *)(&bmask);
		__m128 _mm_mask = _mm_load_ss(fmask);
		_mm_store_ss(rvalf, _mm_and_ss(a_in, _mm_mask));
	)*/

	CUSTOM_PS_OP1
	(
		abs,		
		
		//long const bmask = 0x7FFFFFFF;	
		//float &fmask = *(float *)(&bmask);
		//__m128 _mm_mask = _mm_load_ps1(fmask);
		//__m128 const _mm_mask = { 0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF };
		PS_CVAR_PS1(_mm_mask, 0x7FFFFFFF);
		_mm_store_ps(&rvalf[0], _mm_and_ps(a_in, TO_M128(_mm_mask)));
	)



	CUSTOM_SS_OP1(neg,		rvalf = -af)			   ///we use simple absf because SSE version requires using _mm_and_ss which uses also simple registers

	CUSTOM_PS_OP1
	(
		neg,		
		
		//float const fzero = 0;
		//__m128 _mm_zero = _mm_load_ps1(fzero);
		//__m128 const _mm_zero = { 0x0, 0x0, 0x0, 0x0 };
		_mm_store_ps(&rvalf[0], _mm_sub_ps(_mm_set_ps1(0), a_in));
	)



	CUSTOM_SS_OP1(pow2,		rvalf = af * af)			   ///we use simple absf because SSE version requires using _mm_and_ss which uses also simple registers

	CUSTOM_PS_OP1
	(
		pow2,		
		
		_mm_store_ps(&rvalf[0], _mm_mul_ps(a_in, a_in));
	)


END_DISABLE_WARNING



//END_DISABLE_WARNING			///DISABLE_WARNING(4700)		///warning C4700: uninitialized local variable 'af' used


///#######################################################################



#define BUILD_MM1_FUNCTOR(func)								BUILD_FUNCTOR1(BOOST_PP_CAT(func, _functor), __m128, __m128, rval = func(a);)
#define BUILD_MM1_PS_SS_FUNCTORS(func)											\
																				\
	BUILD_MM1_FUNCTOR(PP_CAT3(_mm_, func, _ps))									\
	BUILD_MM1_FUNCTOR(PP_CAT3(_mm_, func, _ss))									\
																				\
	struct PP_CAT3(_mm_, func, _functor)										\
	{																			\
		typedef PP_CAT3(_mm_, func, _ss_functor)			ss_functor;			\
		typedef PP_CAT3(_mm_, func, _ps_functor)			ps_functor;			\
																				\
		static const bool has_ss_functor					= true;				\
	};																			\


#define BUILD_MM2_FUNCTOR(func)								BUILD_FUNCTOR2(BOOST_PP_CAT(func, _functor), __m128, __m128, __m128, rval = func(a, b);)
#define BUILD_MM2_PS_SS_FUNCTORS(func)											\
																				\
	BUILD_MM2_FUNCTOR(PP_CAT3(_mm_, func, _ps))									\
	BUILD_MM2_FUNCTOR(PP_CAT3(_mm_, func, _ss))									\
																				\
	struct PP_CAT3(_mm_, func, _functor)										\
	{																			\
		typedef PP_CAT3(_mm_, func, _ss_functor)			ss_functor;			\
		typedef PP_CAT3(_mm_, func, _ps_functor)			ps_functor;			\
																				\
		static const bool has_ss_functor					= true;				\
	};																			\


#define BUILD_MM2_PS_FUNCTORS_X(func)											\
																				\
	BUILD_MM2_FUNCTOR(PP_CAT3(_mm_, func, _ps))									\
																				\
	struct PP_CAT3(_mm_, func, _functor)										\
	{																			\
		typedef PP_CAT3(_mm_, func, _ps_functor)			ps_functor;			\
																				\
		static const bool has_ss_functor					= false;			\
	};																			\



#define BUILD_MM1_FUNCTORS(num, ...)						BUILD_MM1_FUNCTORS_I(num, (num, (__VA_ARGS__)))	
#define BUILD_MM1_FUNCTORS_I(num, names_array)				BOOST_PP_REPEAT(num, BUILD_MM1_FUNCTORS__WORKER, names_array) 
#define BUILD_MM1_FUNCTORS__WORKER(z, n, names_array)      BUILD_MM1_PS_SS_FUNCTORS(BOOST_PP_ARRAY_ELEM(n, names_array))

#define BUILD_MM2_FUNCTORS(num, ...)						BUILD_MM2_FUNCTORS_I(num, (num, (__VA_ARGS__)))	
#define BUILD_MM2_FUNCTORS_I(num, names_array)				BOOST_PP_REPEAT(num, BUILD_MM2_FUNCTORS__WORKER, names_array) 
#define BUILD_MM2_FUNCTORS__WORKER(z, n, names_array)      BUILD_MM2_PS_SS_FUNCTORS(BOOST_PP_ARRAY_ELEM(n, names_array))

#define BUILD_MM2_PS_FUNCTORS(num, ...)					BUILD_MM2_PS_FUNCTORS_I(num, (num, (__VA_ARGS__)))	
#define BUILD_MM2_PS_FUNCTORS_I(num, names_array)			BOOST_PP_REPEAT(num, BUILD_MM2_PS_FUNCTORS__WORKER, names_array) 
#define BUILD_MM2_PS_FUNCTORS__WORKER(z, n, names_array)   BUILD_MM2_PS_FUNCTORS_X(BOOST_PP_ARRAY_ELEM(n, names_array))

///#######################################################################
///
///#######################################################################

/*
#if defined(and) 
#   pragma push_macro("and")
#   undef and
#   define and(x)
#endif
*/

BUILD_MM1_FUNCTORS
(
	6,
	sqrt, rsqrt,
	rcp,
	
	pow2,
	abs, neg
)
/*
BUILD_MM2_PS_FUNCTORS
(
	4, 

	and, or,
	andnot, xor
)
*/				  
BUILD_MM2_FUNCTORS
(
	23, //34,					/*current max allowed size for BOOST tuple is 25*/
	
	set,
	min, max,
	
	add, mul,
	sub, div,			///NB sub and div are not commutative
	
	and, or,
	andnot, xor,

	cmpord, cmpunord,
	
	cmpeq, cmpneq,
	cmplt, cmple, cmpngt, cmpnge,
	cmpgt, cmpge, cmpnlt, cmpnle///,
	
	///#######################################################################
/*
	comieq, comineq,
	comilt, comile,
	comigt, comige,
	
	ucomieq, ucomineq,
	ucomilt, ucomile,
	ucomigt, ucomige
*/	
)

/*
#if defined(and) 
#   pragma pop_macro("and")
#endif
*/


///#######################################################################
///
///#######################################################################

template <typename functor, typename blocktype = _ss_block>
struct _mm_xs_worker1;


template <typename functor>
struct _mm_xs_worker1<functor, _ss_block>
{
	static inline void apply(_ss_block &a_out, _ss_block const &a_in1)
	{
		_mm_store_ss(&a_out, functor(_mm_load_ss(&a_in1)));	
	};	

	static inline void apply(_ss_block &a_out, _ss_block const &a_in1, _ss_block const &a_in2)
	{
		_mm_store_ss(&a_out, functor(_mm_load_ss(&a_in1), _mm_load_ss(&a_in2)));	
	};
	
	///#######################################################################
	
	static inline void apply(_ss_block &a_out, _ss_block const &a_in1, __m128 const &a_in2)
	{
		_mm_store_ss(&a_out, functor(_mm_load_ss(&a_in1), a_in2));	
	};
	
	static inline void apply(_ss_block &a_out, __m128 const &a_in1, _ss_block const &a_in2)
	{
		_mm_store_ss(&a_out, functor(a_in1, _mm_load_ss(&a_in2)));	
	};		
};

///#######################################################################

template <typename functor>
struct _mm_xs_worker1<functor, _ps_block>
{
	static inline void apply(_ps_block &a_out, _ps_block const &a_in1)
	{
		_mm_store_ps(&a_out[0], functor(_mm_load_ps(&a_in1[0])));	
	};

	///#######################################################################

	static inline void apply(_ps_block &a_out, _ps_block const &a_in1, _ps_block const &a_in2)
	{
		_mm_store_ps(&a_out[0], functor(_mm_load_ps(&a_in1[0]), _mm_load_ps(&a_in2[0])));	
	};

	///#######################################################################

	static inline void apply(_ps_block &a_out, _ps_block const &a_in1, float const &a_in2)
	{
		_mm_store_ps(&a_out[0], functor(_mm_load_ps(&a_in1[0]), _mm_load_ps1(&a_in2)));	
	};
	
	static inline void apply(_ps_block &a_out, float const &a_in1, _ps_block const &a_in2)
	{
		_mm_store_ps(&a_out[0], functor(_mm_load_ps1(&a_in1), _mm_load_ps(&a_in2[0])));	
	};

	///#######################################################################

	static inline void apply(_ps_block &a_out, _ps_block const &a_in1, __m128 const &a_in2)
	{
		_mm_store_ps(&a_out[0], functor(_mm_load_ps(&a_in1[0]), a_in2));	
	};
	
	static inline void apply(_ps_block &a_out, __m128 const &a_in1, _ps_block const &a_in2)
	{
		_mm_store_ps(&a_out[0], functor(a_in1, _mm_load_ps(&a_in2[0])));	
	};	
		
};

///#######################################################################
///
///#######################################################################

template <typename functor, typename blocktype = _ss_block>
struct _mm_xs_worker1b
{
	static inline void apply(blocktype const &a_in1, blocktype &a_out)			///outparam is last hre
	{
		_mm_xs_worker1<functor, blocktype>::apply(a_out, a_in1);	
	};	

	template <typename a1T, typename a2T>
	static inline void apply(a1T const &a_in1, a2T const &a_in2, blocktype &a_out)			///outparam is last hre
	{
		_mm_xs_worker1<functor, blocktype>::apply(a_out, a_in1, a_in2);	
	};	
};

///#######################################################################
///
///#######################################################################

template <int size, typename functor, int index = 0>
struct _loop_unroller
{
	template <typename p1T, typename p2T, typename outT>	
	static inline void apply(p1T &a_in1, p2T &a_in2, outT &a_out)
	{
		functor::go(index, a_in1, a_in2, a_out);	
				
		_loop_unroller<size, functor, index + 1>::apply(a_in1, a_in2, a_out);
	};
	
	template <typename p1T, typename outT>	
	static inline void apply(p1T &a_in1, outT &a_out)
	{
		functor::go(index, a_in1, a_out);
				
		_loop_unroller<size, functor, index + 1>::apply(a_in1, a_out);
	};	
};

template <int size, typename functor>
struct _loop_unroller<size, functor, size>				///end loop
{													
	template <typename p1T, typename p2T, typename outT>	   
	static inline void apply(p1T &UNUSED(a_in1), p2T &UNUSED(a_in2), outT &UNUSED(a_out)) {};

	template <typename p1T, typename outT>	   
	static inline void apply(p1T &UNUSED(a_in1), outT &UNUSED(a_out)) {};
};

///#######################################################################
///
///#######################################################################

template <int size, typename type = float, int alignment = SSE_ALIGN_VAL>
struct aligned_array_base;
	
	
template <int size, typename type>
struct aligned_array_base<size, type, SSE_ALIGN_VAL>
{
#if ENABLE_SSE_VECTOR
	typedef type __declspec(align(SSE_ALIGN_VAL))		AT[size];
	//BOOST_STATIC_ASSERT(false);
#else	
	typedef type										AT[size];
#endif	


	#ifndef NET_DECLARE_ONLY
	
		DISABLE_SERIALIZE_WARNINGS
	
		ENABLE_SERIALIZE_BASE(myval)
/*						
		//DISABLE_SERIALIZE_WARNINGS
	private:																										
																												
		DISABLE_SERIALIZE_WARNINGS																					
		friend class boost::serialization::access;																	
		template<class Archive>																						
		void serialize(Archive &ar, const unsigned int UNUSED(version))												
		{																											
			SERIALIZE_ENTRY()
			
			
			size_t malloc_alignment_old = malloc_alignment;					///TODO: set alignment only during loading
			malloc_alignment = SSE_ALIGN_VAL;								///NB! 
																									
			ar & myval;																							
			
			malloc_alignment = malloc_alignment_old;
			
		};																											
		END_DISABLE_SERIALIZE_WARNINGS																				
*/		
		
		SERIALIZE_PTRS_TO_STATIC_OBJECTS()
		
			FOR(dim_i, size)
			{
				myval[dim_i].serialize_ptrs_to_static_objects(ar, (unsigned int)-1);		
			}	
		}	
		
		END_DISABLE_SERIALIZE_WARNINGS
		
	#endif							


	ENABLED_SSE_ALIGN AT		myval;	
};

///#######################################################################

template <int size, typename type>
struct aligned_array_base<size, type, 0>
{
	typedef type							AT[size];

	
	#ifndef NET_DECLARE_ONLY		
	
		DISABLE_SERIALIZE_WARNINGS
	
		ENABLE_SERIALIZE_BASE(myval)				
		SERIALIZE_PTRS_TO_STATIC_OBJECTS()
		
			FOR(dim_i, size)
			{
				myval[dim_i].serialize_ptrs_to_static_objects(ar, (unsigned int)-1);		
			}	
		}	
		
		END_DISABLE_SERIALIZE_WARNINGS
		
	#endif							


	AT		myval;	
	
	
};

///#######################################################################

template <int size, typename type = float, int alignment = SSE_ALIGN_VAL>
struct aligned_array : public aligned_array_base<size, type, alignment>
{
	typedef aligned_array_base<size, type, alignment>			parent_T;
	typedef typename parent_T::AT								AT;
	
	typedef type 												AT_simple[size];
	
	///#######################################################################

	inline const type& operator [] (int index) const
	{
		return myval[index];
	};

	inline type& operator [] (int index)
	{
		return myval[index];
	};

	///#######################################################################

	inline operator const AT& () const
	{
		//return *(AT *)(this);
		return reinterpret_cast<const AT&>(*this);
	};
	
	inline operator AT& ()
	{
		//return *(AT *)(this);
		return reinterpret_cast<AT&>(*this);
	};

	///#######################################################################
/*
	inline operator const AT_simple& () const
	{
		//return *(AT *)(this);
		return reinterpret_cast<const AT_simple&>(*this);
	};
	
	inline operator AT_simple& ()
	{
		//return *(AT *)(this);
		return reinterpret_cast<AT_simple&>(*this);
	};
*/	
	///#######################################################################

	inline const AT& get_array() const
	{
		//return *(AT *)(this);
		return reinterpret_cast<const AT&>(*this);
	};
	
	inline AT& get_array()
	{
		//return *(AT *)(this);
		return reinterpret_cast<AT&>(*this);
	};
	
	
};

///#######################################################################
///
///#######################################################################
