

#undef _CRTDBG_MAP_ALLOC
#undef _MFC_OVERRIDES_NEW


#pragma warning (push)
#pragma warning (disable : 6334)
#include <boost/type_traits/is_base_of.hpp>
#pragma warning (pop)


#include <boost/static_assert.hpp>	

template<typename dummy_T> struct always_false	  ///necessary for intel etc two-phase name resolution compilers
{ 
    enum { value = 0 }; 
}; 

#define STATIC_ASSERT(dummy_T)				BOOST_STATIC_ASSERT(always_false<dummy_T>::value);


///###################################################################################

namespace ai
{

	#define S			size_t

///###################################################################################
///
///###################################################################################
	/*
	template <typename conf>
	struct get_my_final_T;

	template <typename conf, S steps_back = 1>
	struct get_pipelines_prev_level_T;

	template <typename conf, S steps_forward = 1>
	struct get_pipelines_next_level_T;
	*/

	///###################################################################################
	///
	///###################################################################################


	#ifndef __INTEL_COMPILER
		#define ALLOW_INSTANTIATIONS	1
	#endif



	#ifdef ALLOW_INSTANTIATIONS			

		#define INSTANTIATE(name)		template name;
		#define INSTANTIATE2(name)
		
	#else						 ///intel compiler does not allow explicit template instatiations in class scope

		#define INSTANTIATE(name)
		#define INSTANTIATE2(name)		template name;
		
	#endif



	#define INSTANTIATE3(name)		template name;



	#define DSS			4096


	struct void_class 
	{
	
	public:	
		typedef void									container_obj_T;
		static const bool call_init_deinit				= true;
		static const S segmentsize						= DSS;	
		
		
		typedef void									input_T;
		typedef void									output_T;
		
	protected:	
		typedef void									value_T;
		
	};
	

	template <typename T>
	struct sllc_wcop {};

	template <typename T>
	struct elem_with_index_a : public T {};

	template <typename T>
	struct elem_with_index_ct : public T {};

}		///namespace ai



#include "../tasand1/pipelines3.h"


using namespace ai;


	#if 0

		///###################################################################################
		///
		///###################################################################################

		///###################################################################################
		///
		///###################################################################################


		#ifndef __INTEL_COMPILER			///intel compiler does not need this crap (although it allows it)

			#define FORWARD_T(T)					FORWARD_TI(parent_T, T)
			#define FORWARD_V(type, name)			FORWARD_VI(parent_T, type, name)

			#define FORWARD_TI(PT, T)				typedef typename PT::T		T;
			#define FORWARD_VI(PT, type, name)		static const type name = PT::name;

		#else

			#define FORWARD_T(T)
			#define FORWARD_V(type, name)
			
			#define FORWARD_TI(PT, T)
			#define FORWARD_VI(PT, type, name)	

		#endif

		#define FORWARD_TW(T)						FORWARD_TI(parent_TA, T)
		#define FORWARD_VW(type, name)				FORWARD_VI(parent_TA, type, name)


		//#define FORWARD_TI(PT, T)					typedef typename PT::T				T;
		//#define FORWARD_VI(PT, type, name)			static const type name = PT::name;




		#define FORWARD_INPUT_T						FORWARD_INPUT_TI(parent_T)										
		#define FORWARD_INPUT_TW					/*FORWARD_INPUT_TI(parent_TA)										*/



		#define FORWARD_INPUT_TI(PT)														\
																							\
		public:																				\
																							\
			FORWARD_TI(PT, input_T)															\
			FORWARD_TI(PT, output_T)														\
			FORWARD_TI(PT, value_T)															\
			/*FORWARD_T(my_final_T)*/														\
																							\
			FORWARD_TI(PT, container_obj_T)													\
																							\
			FORWARD_VI(PT, bool, call_init_deinit)											\
			FORWARD_VI(PT, S, segmentsize)													\
			

		///###################################################################################
		///
		///###################################################################################



		#define GET_PARENTM2(default_T)				get_parent2<conf, default_T >::rT
		#define GET_PARENTM3(default_TC)			GET_PARENTM3_INNER(default_TC)
		#define GET_PARENTM3_INNER(default_TC)		get_parent3<conf, REMOVE_PARENTHESES(default_TC) >::rT

		#define GET_PARENTM31(C, default_TC)				get_parent3<conf, C<default_TC > >::rT
		#define GET_PARENTM32(C, default_TC, C2)			get_parent3<conf, C<default_TC, C2 > >::rT
		#define GET_PARENTM33(C, default_TC, C2, C3)		get_parent3<conf, C<default_TC, C2, C3 > >::rT

		#define TYPEDEF_PARENT2(default_T)		typedef typename get_parent2<conf, default_T>::rT	parent_T;
		//#define MYT(my_type)					typedef my_T parent_T;		typedef my_type my_T;

		#define PARENTT2(default_T)				typedef typename GET_PARENTM2(default_T)	parent_T;	
		#define PARENTT3(default_T)				typedef typename GET_PARENTM3(default_T)	parent_T;	

		//#define PARENTT2PW(wrapper_T)			typedef typename wrapper_T::wparent_T	parent_T;	
		//#define PARENTT3PW(wrapper_T)			typedef typename wrapper_T::wparent_T	parent_T;	
		#define PARENTT2PW(wrapper_T)			typedef wrapper_T<conf>	parent_T;	INSTANTIATE(parent_T) 
		#define PARENTT3PW(wrapper_T)			typedef wrapper_T<conf>	parent_T;	INSTANTIATE(parent_T) 

		#define MYT(my_type)					typedef my_type my_T;   typedef typename get_my_final_T<conf>::rT		my_final_T;

		//#define FORWARD_T(T)					typedef typename parent_T::T				T;
		//#define FORWARD_V(type, name)			static const type name = parent_T::name;




		///TODO: use http://boost.org/libs/preprocessor/doc/index.html here	(Use BOOST_PP_ENUM_PARAMS (and its variants) or BOOST_PP_REPEAT and BOOST_PP_COMMA_IF)

		#define FORWARD_T2(T1, T2)				FORWARD_T(T1) FORWARD_T(T2)
		#define FORWARD_T3(T1, T2, T3)			FORWARD_T(T1) FORWARD_T(T2)	FORWARD_T(T3)
		#define FORWARD_T4(T1, T2, T3, T4)		FORWARD_T(T1) FORWARD_T(T2)	FORWARD_T(T3) FORWARD_T(T4)
		#define FORWARD_T5(T1, T2, T3, T4, T5)	FORWARD_T(T1) FORWARD_T(T2)	FORWARD_T(T3) FORWARD_T(T4)	FORWARD_T(T5)







		//#define PIPELINE_NODE3(node_TT, parent_TT)()			PIPELINE_NODE3_I(node_TT, parent_TT)


		///###################################################################################
		///
		///###################################################################################





		#if defined(_MSC_VER) && (_MSC_VER >= 1400)			///compiler 2005

			//#define REMOVE_PARENTHESES(...)									__VA_ARGS__
			
			
			/*
			# if ~BOOST_PP_CONFIG_FLAGS() & BOOST_PP_CONFIG_MWCC()
			#    define VA_CAT(a, ...) VA_CAT_I(a, __VA_ARGS__)
			# else
			#    define VA_CAT(a, ...) VA_CAT_OO((a, __VA_ARGS__))
			#    define VA_CAT_OO(par) VA_CAT_I ## par
			# endif
			#
			# if ~BOOST_PP_CONFIG_FLAGS() & BOOST_PP_CONFIG_MSVC()
			#    define VA_CAT_I(a, ...) a ## __VA_ARGS__
			# else
			#    define VA_CAT_I(a, ...) VA_CAT_II(a ## __VA_ARGS__)
			#    define VA_CAT_II(...) __VA_ARGS__
			# endif	
			*/
			
			#define IDENT(...)													__VA_ARGS__

			
			#define END_REMOVE_PARENTHESES_INNER__REMOVE_PARENTHESES_INNER
			#define END_REMOVE_PARENTHESES_INNER__REMOVE_PARENTHESES_INNER2
			#define END_REMOVE_PARENTHESES_INNER__REMOVE_PARENTHESES_INNER3
				
			#define REMOVE_PARENTHESES_INNER3(...)								__VA_ARGS__
			#define REMOVE_PARENTHESES_INNER2(...)								IDENT(REMOVE_PARENTHESES_INNER3 __VA_ARGS__)
			#define REMOVE_PARENTHESES_INNER(...)								IDENT(REMOVE_PARENTHESES_INNER2 __VA_ARGS__)
			#define REMOVE_PARENTHESES(...)									FINALIZE_REMOVE_PARENTHESES(REMOVE_PARENTHESES_INNER __VA_ARGS__)
			
			#define FINALIZE_REMOVE_PARENTHESES(...)							FINALIZE_REMOVE_PARENTHESES_I(__VA_ARGS__)
			#define FINALIZE_REMOVE_PARENTHESES_I(...)							END_REMOVE_PARENTHESES_INNER__##__VA_ARGS__

			
			
			//#define PIPELINE_NODE3(node_TT, parent_TT)							PIPELINE_NODE3_I(node_TT, REMOVE_PARENTHESES parent_TT)
			#define PIPELINE_NODE3_INNER2(node_TT, inheritance, parent_TT, ...)		PIPELINE_NODE3_INNER(node_TT, inheritance, parent_TT, __VA_ARGS__)





			#define PIPELINE_NODE31_I(node_TT, C, pT1)							PIPELINE_NODE3(node_TT, (C<pT1>))
			#define PIPELINE_NODE32_I(node_TT, C, pT1, PT2)					PIPELINE_NODE3(node_TT, (C<pT1, PT2>))
			#define PIPELINE_NODE33_I(node_TT, C, pT1, PT2, PT3)				PIPELINE_NODE3(node_TT, (C<pT1, PT2, PT3>))

		#else

			#define PIPELINE_NODE31(node_TT, parent_TT)							PIPELINE_NODE31_I(node_TT, parent_TT)
			#define PIPELINE_NODE32(node_TT, parent_TT)							PIPELINE_NODE32_I(node_TT, ##parent_TT)
			#define PIPELINE_NODE33(node_TT, parent_TT)							PIPELINE_NODE33_I(node_TT, ##parent_TT)

			//#define PIPELINE_NODE3(node_TT, parent_TT)							PIPELINE_NODE3_I(node_TT, parent_TT)

			#define PIPELINE_NODE31_I(node_TT, C, pT1)							PIPELINE_NODE31_I2(node_TT, C, pT1)
			#define PIPELINE_NODE32_I(node_TT, C, pT1, PT2)					PIPELINE_NODE32_I2(node_TT, C, pT1, PT2)
			#define PIPELINE_NODE33_I(node_TT, C, pT1, PT2, PT3)				PIPELINE_NODE33_I2(node_TT, C, pT1, PT2, PT3)

		#endif



		#define TYPEDEFS(...)													REMOVE_PARENTHESES(__VA_ARGS__)

		/*
		TYPEDEFS_INNER2(REMOVE_PARENTHESES(__VA_ARGS__))
		//#define TYPEDEFS_INNER1(...)											TYPEDEFS_INNER2(REMOVE_PARENTHESES(__VA_ARGS__))
		#define TYPEDEFS_INNER2(...)											__VA_ARGS__
		*/

		///###################################################################################
		///
		///###################################################################################



		/*
		#define PIPELINE_NODE31_I(node_TT, pT1)							PIPELINE_NODE3(node_TT, pT1)
		#define PIPELINE_NODE32_I(node_TT, pT1, PT2)					PIPELINE_NODE3(node_TT, PL<pT1, PT2>)
		#define PIPELINE_NODE33_I(node_TT, pT1, PT2, PT3)				PIPELINE_NODE3(node_TT, PL<pT1, PT2, PT3>)
		*/


		//#if 1


		#define PIPELINE_NODE2(node_TT, parent_TT, ...)		PIPELINE_NODE2_INNER(node_TT, public,		parent_TT, __VA_ARGS__)
		#define PIPELINE_NODE2_O(node_TT, parent_TT, ...)		PIPELINE_NODE2_INNER(node_TT, protected,	parent_TT, __VA_ARGS__)
		#define PIPELINE_NODE2_I(node_TT, parent_TT, ...)		PIPELINE_NODE2_INNER(node_TT, private,		parent_TT, __VA_ARGS__)

		#define PIPELINE_NODE3(node_TT, parent_TT, ...)		PIPELINE_NODE3_INNER2(node_TT, public,		parent_TT, __VA_ARGS__)
		#define PIPELINE_NODE3_O(node_TT, parent_TT, ...)		PIPELINE_NODE3_INNER2(node_TT, protected,	parent_TT, __VA_ARGS__)
		#define PIPELINE_NODE3_I(node_TT, parent_TT, ...)		PIPELINE_NODE3_INNER2(node_TT, private,		parent_TT, __VA_ARGS__)


		#define PIPELINE_NODE2_INNER(node_TT, inheritance, parent_TT, ... /*typedefs*/)					\
				PIPELINE_NODE2_INNER2(node_TT, inheritance, (typename GET_PARENTM2(parent_TT)), (__VA_ARGS__) /*typedefs*/)

		#define PIPELINE_NODE2_INNER2(node_TT, inheritance, parent_M, ...)							\
				PIPELINE_NODE2_INNER3(node_TT, inheritance, parent_M, __VA_ARGS__)


		///###################################################################################



		#define PIPELINE_NODE2_INNER3(node_TT, inheritance, parent_M, typedefs)					\
																									\
		template <typename conf, typename parent_TA = REMOVE_PARENTHESES(parent_M) >				\
		class node_TT##__PW : public parent_TA {};													\
																									\
																									\
		template <typename conf, bool isdata>														\
		class node_TT/* : public node_TT##__PW<conf> {}*/;											\
																									\
		template <typename conf>																	\
		class node_TT <conf, false> : inheritance node_TT##__PW<conf>							    \
		{																							\
		public:																						\
			MYT(node_TT)																			\
			PARENTT2PW(node_TT##__PW)																\
																									\
		public:																						\
			TYPEDEFS(typedefs)																		\
		};																							\
																									\
		template <typename conf>																	\
		class node_TT <conf, true> : public node_TT##__PW<conf>										\
		{																							\
		public:																						\
			MYT(node_TT)																			\
			PARENTT2PW(node_TT##__PW)																\
			FORWARD_INPUT_T																			\
																									\
		private:																					\


		///###################################################################################


		#define PIPELINE_NODE3_INNER(node_TT, inheritance, parent_TT, typedefs)					\
																									\
		template <typename conf, typename parent_TA = typename GET_PARENTM3(parent_TT) >			\
		class node_TT##__PW : public parent_TA {};													\
																									\
																									\
		template <typename conf, bool isdata>														\
		class node_TT/* : public node_TT##__PW<conf> {}*/;											\
																									\
		template <typename conf>																	\
		class node_TT <conf, false> : inheritance node_TT##__PW<conf>							    \
		{																							\
		public:																						\
			MYT(node_TT)																			\
			PARENTT3PW(node_TT##__PW)																\
																									\
		public:																						\
			TYPEDEFS(typedefs)																		\
		};																							\
																									\
		template <typename conf>																	\
		class node_TT <conf, true> : public node_TT##__PW<conf>										\
		{																							\
		public:																						\
			MYT(node_TT)																			\
			PARENTT3PW(node_TT##__PW)																\
			FORWARD_INPUT_T																			\
																									\
		private:																					\

		///###################################################################################
		///
		///###################################################################################

		struct void_class {};

		//PIPELINE_NODE2_INNER2
		PIPELINE_NODE2_WITH_PWRAPPER_INNER2(void_pipeline_class, public, void_class,

		protected:

			//typedef void_pipeline_class					my_T;
			//typedef typename get_my_final_T<conf>::rT		my_final_T;
			
		public:	
			typedef void									container_obj_T;
			static const bool call_init_deinit				= true;
			static const S segmentsize						= 4096;	
			
			
			typedef void									input_T;
			typedef void									output_T;
			
		protected:	
			typedef void									value_T;

		)
		};

		///###################################################################################
		///
		///###################################################################################

		///###################################################################################
		///
		///###################################################################################

		static const S elem_conf_default_num_param		= 0;
		struct											DT {};	//elem_conf_default_type_param {};
		//static const bool elem_conf_default_bool_param	= false;
		static const bool elem_conf_default_bool_param	= false;

		///###################################################################################

		/*
		template <typename conf, bool isdata>
		class void_pipeline_class {

		};
		*/

		///###################################################################################

		struct DI {};		//default_inheritance_struct
		struct inheritance_conf_struct_base {};
		struct pipeline_conf_struct_base {};
		struct default_pipeline_conf {};
		struct default_pipeline_level_full {};

		///###################################################################################
		///
		///###################################################################################

		template
		<
			typename						param1		= DT, //elem_conf_default_type_param,
			typename						param2		= DT, //elem_conf_default_type_param,
			typename						param3		= DT, //elem_conf_default_type_param,
			typename						param4		= DT //elem_conf_default_type_param
		>
		struct EP	//elem_params_struct
		{	
			typedef param1					param1;
			typedef param2					param2;
			typedef param3					param3;
			typedef param4					param4;
		};

		typedef EP<>		default_elem_params;

		///###################################################################################

		struct DP			   ///default_parent_struct
		{};

		///###################################################################################
		///
		///###################################################################################

		///TODO: use http://boost.org/libs/preprocessor/doc/index.html here	(Use BOOST_PP_ENUM_PARAMS (and its variants) or BOOST_PP_REPEAT and BOOST_PP_COMMA_IF)

		template
		<
			template <typename conf1, bool isdata1> class	parent_T_in,
			
			typename						param1		= DT, //elem_conf_default_type_param,
			typename						param2		= DT, //elem_conf_default_type_param,
			typename						param3		= DT, //elem_conf_default_type_param,
			typename						param4		= DT //elem_conf_default_type_param
		>
		struct EC		///elem_conf
		{
			template <typename conf, bool isdata = conf::isdata>
			struct GR	//get_parent
			{
				typedef parent_T_in<conf, isdata>		rT;
			};

			typedef EP		//elem_params_struct
			<
				param1,
				param2,
				param3,
				param4
			>
			elem_params;
		};	

		#define pe		EC

		///###################################################################################
		///
		///###################################################################################

		template
		<
			S pipeline_T_index__in,
			S level_in_pipeline__in,
			S actual_inheritance_level__in,
			S level_in_inheritance_struct__in,
			
			bool isdata__in,
			bool is_abstract_tree__in,
			
			typename inheritance_struct,	//								= global_default_inheritance_struct								///inheritance conf 
			typename pipelines_collection,
			
			typename elem_params			//							    = elem_params_struct<>
		>
		struct CS	 //conf_struct2
		{
			static const S pipeline_T_index									= pipeline_T_index__in;
			static const S level_in_pipeline								= level_in_pipeline__in;
			static const S actual_inheritance_level							= actual_inheritance_level__in; 
			static const S level_in_inheritance_struct						= level_in_inheritance_struct__in;
			
			static const bool isdata										= isdata__in;
			static const bool is_abstract_tree								= is_abstract_tree__in;
			
			typedef inheritance_struct										inheritance_struct;
			typedef pipelines_collection									pipelines_collection;
			
			
			typedef typename pipelines_collection::template get_pipeline_T<pipeline_T_index>::rT		pipeline_conf;
			
			
			typedef elem_params												elem_params;
		};

		///###################################################################################
		///
		///###################################################################################

		template
		<
			//typename pipeline_conf,
			typename pipelines_collection,
			S pipeline_T_index,
			S level_in_pipeline,

			typename elem_conf_0,																			   
			typename elem_conf_1		= DP,
			typename elem_conf_2		= DP,
			typename elem_conf_3		= DP,
			typename elem_conf_4		= DP
		>
		struct pipeline_level_full : public inheritance_conf_struct_base 
		{
			typedef elem_conf_0			conf_for_level_0;
			typedef elem_conf_1			conf_for_level_1;
			typedef elem_conf_2			conf_for_level_2;
			typedef elem_conf_3			conf_for_level_3;
			typedef elem_conf_4			conf_for_level_4;
			
			
			
			typedef typename elem_conf_0::template GR
			<
				CS
				<
					pipeline_T_index,
					level_in_pipeline,
					0,
					0,
					
					true,			///isdata
					false,			///is_abstract_tree
					
					DI,	//pipeline_level_full,				///inheritance struct
					//pipeline_conf,						///pipeline			
					pipelines_collection,
					
					typename elem_conf_0::elem_params
				>
			>::rT 
			pipeline_level_final_T;	
			
			
			
			typedef typename elem_conf_0::template GR
			<
				CS
				<
					pipeline_T_index,
					level_in_pipeline,
					0,
					0,
					
					false,			///isdata
					true,			///is_abstract_tree
					
					DI,	//pipeline_level_full,				///inheritance struct
					//pipeline_conf,						///pipeline			
					pipelines_collection,
					
					typename elem_conf_0::elem_params
				>
			>::rT 
			pipeline_level_final_abstract_T;	
			
		};

		///###################################################################################
		///
		///###################################################################################

		struct default_pipeline_level
		{
			template 
			<
				//typename pipeline_conf,
				typename pipelines_collection,
				S pipeline_T_index,
				S level_in_pipeline
			>
			struct get_pipeline_level_full
			{
				typedef default_pipeline_level_full				rT;
			};
		}; 

		template
		<
			typename elem_conf_0,
			typename elem_conf_1		= DP,
			typename elem_conf_2		= DP,
			typename elem_conf_3		= DP,
			typename elem_conf_4		= DP
		>
		struct PL	   ///pipeline_level
		{
			typedef elem_conf_0			conf_for_level_0;
			typedef elem_conf_1			conf_for_level_1;
			typedef elem_conf_2			conf_for_level_2;
			typedef elem_conf_3			conf_for_level_3;
			typedef elem_conf_4			conf_for_level_4;
			
			
			///get_pipeline_level_full
			template 
			<
				//typename pipeline_conf,
				typename pipelines_collection,
				S pipeline_T_index,
				S level_in_pipeline
			>
			struct get_pipeline_level_full 
			{
				typedef pipeline_level_full
				<
					//pipeline_conf,
					pipelines_collection,
					pipeline_T_index,
					level_in_pipeline,

					elem_conf_0,
					elem_conf_1,
					elem_conf_2,
					elem_conf_3
				>
				rT;
			};
		};

		///###################################################################################
		///
		///###################################################################################

		template
		<
			typename pipelines_collection,
			S pipeline_T_index__in,

			typename pipeline_level_1_conf,
			typename pipeline_level_2_conf		= default_pipeline_level,
			typename pipeline_level_3_conf		= default_pipeline_level,
			typename pipeline_level_4_conf		= default_pipeline_level
		>
		struct pipeline_full : public pipeline_conf_struct_base		 ///pipeline_builder
		{

			typedef pipelines_collection				pipelines_collection;
			static const S pipeline_T_index				= pipeline_T_index__in;



			//typedef pipeline_full						pipeline_conf;


			///levels
			typedef typename pipeline_level_1_conf::template get_pipeline_level_full<pipelines_collection, pipeline_T_index, 1>::rT		pipeline_level_1;	
			typedef typename pipeline_level_2_conf::template get_pipeline_level_full<pipelines_collection, pipeline_T_index, 2>::rT		pipeline_level_2;	
			typedef typename pipeline_level_3_conf::template get_pipeline_level_full<pipelines_collection, pipeline_T_index, 3>::rT		pipeline_level_3;	
			typedef typename pipeline_level_4_conf::template get_pipeline_level_full<pipelines_collection, pipeline_T_index, 4>::rT		pipeline_level_4;	

			
			
			///get_pipeline_level<level>
			template <S level>
			struct get_pipeline_level;

			template <> struct get_pipeline_level <1> { typedef pipeline_level_1				rT; };	
			template <> struct get_pipeline_level <2> { typedef pipeline_level_2				rT; };	
			template <> struct get_pipeline_level <3> { typedef pipeline_level_3				rT; };	
			template <> struct get_pipeline_level <4> { typedef pipeline_level_4				rT; };	
			
			template <> struct get_pipeline_level <5> { typedef default_pipeline_level_full		rT; };	
																		 	
			
			///entry_T and exit_T
			typedef typename pipeline_level_1::pipeline_level_final_T													pipeline_entry_final_T;		   ///entry_T
			typedef typename pipeline_level_1::pipeline_level_final_abstract_T											pipeline_entry_final_abstract_T;		   ///entry_T
			
			
			template
			<
				typename last_level_T	= default_pipeline_level,
				S level					= 0
			>
			struct get_pipeline_exit_final_T
			{
				template <typename last_level_final_T, typename next_pipeline_level>
				struct go
				{
					typedef typename next_pipeline_level::pipeline_level_final_T										new_last_level_final_T;			
					typedef typename get_pipeline_exit_final_T<new_last_level_final_T, level + 1>::rT					rT;
				};
				
				template <typename last_level_final_T>
				struct go<last_level_final_T, default_pipeline_level_full>
				{
					typedef last_level_final_T																			rT;	
				};
				
				
				typedef	typename get_pipeline_level<level + 1>::rT														next_pipeline_level;
				typedef typename go<last_level_T, next_pipeline_level>::rT												rT;	
			};		
			
			typedef typename get_pipeline_exit_final_T<pipeline_entry_final_T, 0>::rT									pipeline_exit_final_T;	 ///exit_T	
		};

		///###################################################################################
		///
		///###################################################################################

		template <S level_in_inheritance_struct, typename inheritance_struct>
		struct get_parent_elem_conf_for_level
		{
			template <S level_in_inheritance_struct> struct go;
			
			
			template <> struct go<0> { typedef typename inheritance_struct::conf_for_level_0				rT; };	
			template <> struct go<1> { typedef typename inheritance_struct::conf_for_level_1				rT; }; 	
			template <> struct go<2> { typedef typename inheritance_struct::conf_for_level_2				rT; };	
			template <> struct go<3> { typedef typename inheritance_struct::conf_for_level_3				rT; };	
			template <> struct go<4> { typedef typename inheritance_struct::conf_for_level_4				rT; };	
			
			
			typedef typename go<level_in_inheritance_struct>::rT					rT;
		};	

		///###################################################################################
		///
		///###################################################################################

		template <typename conf, template <typename conf1, bool isdata1> class local_default_parent = void_pipeline_class>
		struct GP		///get_parent2			  ///local conf has simple class specified as default parent
		{

			
			
			template <bool isdata, S inheritance_level_plus>
			struct GI	///get_parent inner
			{	

				//typedef typename conf::inheritance_struct																				global_inheritance_struct; 
				
				typedef typename conf::pipelines_collection																				pipelines_collection;
				typedef typename conf::pipeline_conf																					global_pipeline_conf;
				typedef typename global_pipeline_conf::template get_pipeline_level<conf::level_in_pipeline>::rT							global_inheritance_struct;
				typedef typename get_parent_elem_conf_for_level<conf::level_in_inheritance_struct + inheritance_level_plus, global_inheritance_struct>::rT	parent_elem_conf_at_global_conf;
				
				
				
				
				///selects parent and sets ITS conf
				template <typename parent_elem_conf_at_global_conf_in>	///global conf has info for parent
				struct SP	//select_parent
				{	
					typedef CS
					<
						conf::pipeline_T_index,
						conf::level_in_pipeline,
						conf::actual_inheritance_level + inheritance_level_plus, 
						conf::level_in_inheritance_struct + inheritance_level_plus, 
						
						isdata,
						conf::is_abstract_tree,
						
						DI,		//global_inheritance_struct,
						pipelines_collection,	//global_pipeline_conf,
						
						typename parent_elem_conf_at_global_conf_in::elem_params
					>																													PC;	//conf_struct_for_parent;
				
					typedef typename parent_elem_conf_at_global_conf_in::template GR<PC>::rT								rT;
				};
				
				template <>
				struct SP <DP>  ///global conf does not have info for parent
				{ 		
					typedef typename conf::inheritance_struct																				local_inheritance_struct;
					
					
					template <typename local_inheritance_struct_in>
					struct SQ	//select_parent2
					{
						typedef typename get_parent_elem_conf_for_level<conf::level_in_inheritance_struct + 1, local_inheritance_struct_in>::rT		parent_elem_conf_at_local_conf;
					
						typedef CS
						<
							conf::pipeline_T_index,
							conf::level_in_pipeline,
							conf::actual_inheritance_level + inheritance_level_plus, 
							conf::level_in_inheritance_struct + inheritance_level_plus, 
							
							isdata,
							conf::is_abstract_tree,
							
							local_inheritance_struct_in,		
							pipelines_collection,	//global_pipeline_conf,
							
							typename parent_elem_conf_at_local_conf::elem_params																					    
						>																													PC;		//conf_struct_for_parent;
					
						typedef typename parent_elem_conf_at_local_conf::template GR<PC>::rT									rT;
					};
					
					template <>
					struct SQ <DI>
					{
						typedef CS
						<
							conf::pipeline_T_index,
							conf::level_in_pipeline,
							conf::actual_inheritance_level + inheritance_level_plus, 
							conf::level_in_inheritance_struct + inheritance_level_plus, 
							
							isdata,
							conf::is_abstract_tree,
							
							DI,		
							pipelines_collection,	//global_pipeline_conf,
							
							default_elem_params																						    
						>																													PC;		//conf_struct_for_parent;
					
						typedef local_default_parent<PC, isdata>																rT;
					};
					
					
					typedef typename SQ<local_inheritance_struct>::rT														rT;
				}; 
				
				
				typedef typename SP<parent_elem_conf_at_global_conf>::rT														rT;		 ///lets decide whether use parent in global conf or in local conf
			};///struct GI	///get_parent inner
			
			
			///###################################################################################
			
			
			template <bool is_abstract_tree> struct EA;		///select_abstraction
			
			template <> struct EA <true>		///its full abstract tree
			{
				typedef typename GI<false, 1>::rT																			rT;
			};
			
			template <> struct EA <false>	    ///mixed tree, lets select sublevel abstraction and level number
			{
				template <bool isdata>
				struct ED;			///select_data
				
				template <> struct ED <true>	///mixed tree; data sublevel, lets take same level's abstract sublevel
				{
					typedef typename GI<false, 0>::rT																			rT;					
				};
				
				template <> struct ED <false>	 ///mixed tree; abstract sublevel, lets take next level with data sublevel 
				{
					typedef typename GI<true, 1>::rT																			rT;
				};
				
				
				typedef typename ED<conf::isdata>::rT																		rT;		
			};
			
			
			typedef typename EA<conf::is_abstract_tree>::rT																		rT;
			
			
		};	///struct GP		///get_parent2

		#define get_parent2		GP

		///###################################################################################
		///
		///###################################################################################

		template <typename conf, S steps_back = 1>
		struct get_pipelines_prev_level_abstract_T
		{
			typedef typename conf::pipeline_conf																					global_pipeline_conf;
			typedef typename global_pipeline_conf::template get_pipeline_level<conf::level_in_pipeline - steps_back>::rT			prev_pipeline_level;
			typedef typename prev_pipeline_level::pipeline_level_final_abstract_T													rT;
		};

		template <typename conf, S steps_back = 1>
		struct get_pipelines_prev_level_output_T
		{
			typedef typename get_pipelines_prev_level_abstract_T<conf, steps_back>::rT			prev_level_T;	
			typedef typename prev_level_T::output_T										rT;
		};

		template <typename conf, S steps_back>
		struct get_pipelines_prev_level_T
		{

			typedef typename conf::pipeline_conf																					global_pipeline_conf;
			typedef typename global_pipeline_conf::template get_pipeline_level<conf::level_in_pipeline - steps_back>::rT			prev_pipeline_level;
			typedef typename prev_pipeline_level::pipeline_level_final_T															rT;

		};
			
		///###################################################################################

		template <typename conf, S steps_forward>
		struct get_pipelines_next_level_T
		{

			typedef typename conf::pipeline_conf																					global_pipeline_conf;
			typedef typename global_pipeline_conf::template get_pipeline_level<conf::level_in_pipeline + steps_forward>::rT			next_pipeline_level;
			typedef typename next_pipeline_level::pipeline_level_final_T															rT;

		};

		///###################################################################################

		template <typename conf>
		struct get_my_final_T
		{

			typedef typename conf::pipeline_conf																					global_pipeline_conf;
			typedef typename global_pipeline_conf::template get_pipeline_level<conf::level_in_pipeline>::rT							next_pipeline_level;
			typedef typename next_pipeline_level::pipeline_level_final_T															rT;

		};

	#endif

///###################################################################################
///
///###################################################################################

///###################################################################################
///
///###################################################################################


PIPELINE_NODE2_INNER(L1_I0, public, void_pipeline_class,

public:
	typedef float																output_T;
	typedef typename get_pipelines_next_level_T<conf>::rT						elem_T;
)


public:

	void somemethod0()
	{
	
	};
};

///###################################################################################

PIPELINE_NODE2_INNER(L1_I1, public, L1_I0,

	//typedef void																output_T;
	
//public:
//	typedef float																output_T;
//	typedef typename get_pipelines_next_level_T<conf>::rT						elem_T;	
)



public:

	void somemethod1()
	{
	
	};
	
	
};

///###################################################################################

PIPELINE_NODE2_INNER(L1_I2, public, L1_I1,

	//typedef float																output_T;
)

public:
	FORWARD_T(elem_T)				 //MSV compiler requires "type forwarding" here
	//FORWARD_T(output_T)
	
	output_T		dataout;
	elem_T			data;	
	
	
	
	
public:

	void somemethod2()
	{
	
	};
		
};

///###################################################################################

PIPELINE_NODE2_INNER(L1_I3, public, L1_I2,)

public:

	void somemethod3()
	{
	
	};
};

///###################################################################################

PIPELINE_NODE2_INNER(L2_I1, public, void_pipeline_class,

	typedef typename get_pipelines_prev_level_output_T<conf>::rT							input_T;		   ///for accessing type's subelements we need to obtain them through abstract type	
	typedef typename get_pipelines_prev_level_T<conf>::rT									prev_level_T;	   ///if we dont try to access type's subelements, then we can read even the full type, not only abstract type
)

public:

	//FORWARD_T(input_T)
	FORWARD_T(prev_level_T)

	input_T			innervar;
	prev_level_T	*ptr_to_prev_level;

};

///###################################################################################
///
///###################################################################################

struct pipelines_collection
{
	typedef pipelines_collection		my_T;


	template <S index> struct get_pipeline_T;	  


	typedef pipeline_full
	<
		my_T, 1,								 	
		
		PL<pe<L1_I3>, pe<L1_I2>, pe<L1_I1>, pe<L1_I0> >,
		PL<pe<L2_I1> >		
	> 
	my_pipeline_T;	
	
	template <>	struct get_pipeline_T<1> { typedef my_pipeline_T	rT; };
	
	
	
	my_pipeline_T::pipeline_entry_final_T	*inputs;
};
	

pipelines_collection::my_pipeline_T										myvar;
pipelines_collection::my_pipeline_T::pipeline_entry_final_T				entryvar;
pipelines_collection::my_pipeline_T::pipeline_entry_final_T::elem_T		entryvar_innervar;



struct tasand : public pipelines_collection
{
public:
	void go()
	{
		inputs->somemethod0();
		inputs->somemethod1();
		inputs->somemethod2();
		inputs->somemethod3();	
	};						   
};

///###################################################################################
///
///###################################################################################

#if 0
struct B1;
struct A3;


struct B1 
{
	typedef A3::output_T				input_T;
	
	input_T								innervar;
};



struct A1
{
	typedef B1							elem_T;
	
	//elem_T								data[10];
};

struct A2 : public A1
{

};

struct A3 : public A2
{
	typedef float						output_T;
	
	elem_T								data[10];
};


#endif

///###################################################################################
///
///###################################################################################

int main()
{
	
	

	return 0;
}

