/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################



















#ifndef TASANDID_STDAFX_H
#define TASANDID_STDAFX_H




/// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif
			   



#pragma message("Compiling tasandid_stdafx.h - this should happen just once per project.\n")






///see http://www.boost.org/libs/spirit/doc/subrules.html
#pragma inline_depth (255)
#pragma inline_recursion (on)


///You cannot turn float_control precise off when except is on. Similarly, precise cannot be turned off when fenv_access is on. 
///To go from strict model to a fast model with the float_control pragma, use the following code:
#pragma float_control(except, off)
#pragma fenv_access(off)					///actually its off by default   - Disables (ON) or enables (OFF) optimizations that could change flag tests and mode changes.
#pragma float_control(precise, off)
#pragma fp_contract(on)						///actually its on by default





#define _CRT_SECURE_NO_WARNINGS
#define _SECURE_SCL 0			   ///throw away all VS security related enhancements.





#define DISABLE_LEAK_DETECTION					1				///just for now





#if _DEBUG && !DISABLE_LEAK_DETECTION
	#ifndef _CRTDBG_MAP_ALLOC
		#define _CRTDBG_MAP_ALLOC
	#endif
#endif

#ifndef _MFC_OVERRIDES_NEW
	#define _MFC_OVERRIDES_NEW
#endif




#define INCLUDE_BOOST_BINARY_ARCHIVE


							


//#pragma warning (disable: 4221 4503 4786)				  			



//#ifdef INCLUDE_BOOST_BINARY_ARCHIVE


#ifndef NET_DECLARE_ONLY




#if defined(_MSC_VER) && (_MSC_VER < 1400)
	
	#pragma warning (disable: 4616)			///#pragma warning : warning number 'x' out of range, must be between '4001' and '4999'

#endif



/*	
	#ifdef _DEBUG
		#undef _DEBUG
		#define NDEBUG
		#define _DEBUG_X
	#endif
*/


///in our code this warning usually means code logic error, not just performance warning
#pragma warning (error: 4800)    ///warning C4800: 'definitions::S' : forcing value to bool 'true' or 'false' (performance warning)
#pragma warning (error: 4716)	  ///warning C4716  '...' : must return a value

///the following warnings cause compilations eventually to fail with VS claiming "unexpected precompiled header error" 
//#pragma warning (error: 4503)	  ///'identifier' : decorated name length exceeded, name was truncated
#pragma warning (error: 4786 4788)		///'identifier' : identifier was truncated to 'number' characters
#pragma warning (error: 4002)				  ///promote to error - too many actual parameters for macro 'identifier'






#pragma optimize ("gt", on)		  ///Enable global optimizations. Specify fast sequences of machine code.






	///for memory_manager.h
	//#define _CRTDBG_MAP_ALLOC						///memory leak debugging support
	#include <stdlib.h>							///for memory_manager.h
	#include "my_crtdbg.h"						    ///for memory_manager.h




//for macros.h
#include <xmmintrin.h>
#include <intrin.h>					//__debugbreak





	#pragma warning (push)
	//#pragma warning (disable: 4503 4244 4267 4786)
	#pragma warning (disable: 4503)
	#pragma warning (disable: 4244 4267)
	#pragma warning (disable: 4100 4244 4267 4512 6011 6326 6334 6385 6386)				   ///roland

	
	//__cdecl
	//{

		#include <boost/archive/binary_iarchive.hpp>					  ///must be included before other serialization headers
		#include <boost/archive/binary_oarchive.hpp>					  ///must be included before other serialization headers

		#include <boost/serialization/list.hpp>					///for nonlinear assoc_cell
		#include <boost/serialization/vector.hpp>			   ///for future
		#include <boost/serialization/map.hpp>					///for nonlinear assoc_cell
		#include <boost/serialization/hash_map.hpp>					///for nonlinear assoc_cell
		
		#include <boost/serialization/split_member.hpp>		   ///Splitting serialize into save/load for nonlinear assoc_cell

		#include <boost/serialization/base_object.hpp>
		
		#include <boost/serialization/export.hpp>			   ///manual registration of classes	// export.hpp header should be last;


	
	//}

	//#pragma warning (default: 4100 4512 4244 4267 4503)				   ///roland
	#pragma warning (pop)




	#include <boost/functional/hash.hpp>




	#include <boost/filesystem/operations.hpp>		///filesize


	#include <boost/utility.hpp>				///next and prior iterator utilities




	#include <boost/preprocessor.hpp> 

	#include <boost/preprocessor/detail/is_nullary.hpp>				///undocumented macros, dont work with Borland compiler
	#include <boost/preprocessor/detail/is_unary.hpp>				///undocumented macros, dont work with Borland compiler
	#include <boost/preprocessor/detail/is_binary.hpp>				///undocumented macros, dont work with Borland compiler
	
	//#include <boost/preprocessor/cat.hpp>			 ///for pipelines3.h
	//#include <boost/preprocessor/stringize.hpp>		 ///general messages



	#pragma warning (push)
	#pragma warning (disable : 6334)						  ///warning C6334: sizeof operator applied to an expression with an operator might yield unexpected results
	#include <boost/type_traits/is_base_of.hpp>			///for pipelines3.h
	#include <boost/type_traits/is_void.hpp>
	#pragma warning (pop)
	
	
	
	
	
	#include <boost/random.hpp> 
	
	
	
	
	#define BOOST_PARAMETER_MAX_ARITY	10
	#include <boost/parameter.hpp>
	
	
	
	
	#include <boost/lambda/construct.hpp>
	#include <boost/bind.hpp>
	
	#pragma warning (push)
	#pragma warning (disable : 6334)						  ///warning C6334: sizeof operator applied to an expression with an operator might yield unexpected results	
	#include <boost/function.hpp>
	#pragma warning (pop)
	
	
	
	#define BOOST_TYPEOF_SUPRESS_UNNAMED_NAMESPACE				 //implementation by roland
	#define BOOST_TYPEOF_SILENT								 //skip the message 'using compliant imlementation'
	#include <boost/typeof/typeof.hpp>
	

/*
	#ifdef _DEBUG_X
		#undef _DEBUG_X
		#undef NDEBUG
		#define _DEBUG 1
		
		
		
		
		//roland : code taken from invarg.c
		_CRTIMP void __cdecl _invalid_parameter(
			const wchar_t *pszExpression,
			const wchar_t *pszFunction,
			const wchar_t *pszFile,
			unsigned int nLine,
			uintptr_t pReserved
		);
				
		_CRTIMP void __cdecl _invalid_parameter_noinfo(void);
		
		
	#endif
*/	


	//#endif		//#ifdef INCLUDE_BOOST_BINARY_ARCHIVE







	//#ifdef _DEBUG
	#include "../debug_semaphore.h"
	//#endif




	///for tasand1.h
	#include <fstream>						///for net status load/save
	
	/*
	#pragma warning (push)
	//#pragma warning (disable : 6011)		///warning C6011: Dereferencing NULL pointer '_Myptr': Lines: 108, 111, 112, 122
	#include <string>
	#pragma warning (pop)
	*/



	///for definitions.h
	#include <assert.h>				    ///for definitions.h




	///for macros.h
	//#include <xmmintrin.h>
	//#include <intrin.h>			///cpuid




	///for cvop::h
	#define _USE_MATH_DEFINES		///enables M_PI	
	#include <math.h>



	///for get_innercells(OUT CHART_DATA_STRUCT *values_out_a) 
	//#include <list>								///already defined in boost
	//#include <vector>
	#include <algorithm>			///std::min
	
	

	#include "../datastructures/memory_manager.h"	  ///for linked_list.h
	
	
	
	
	
	
	
	
	
#else

	#include <list>				///for case of NET_DECLARE_ONLY	
	#include <vector>





#endif





#include <boost/type_traits.hpp>			///for linked_list






///for memory_manager.h
///for definitions.h
#include <stddef.h>					///_W64 data type	//for memory_manager.h
///#include <stddef.h>					///NULL					 //for definitions.h







///for cell_value.h
#pragma warning (push)
//#pragma warning (disable : 6011)		///warning C6011: Dereferencing NULL pointer '_Myptr': Lines: 108, 111, 112, 122
#include <string>
#pragma warning (pop)

#include <sstream>






///for status_vector.h
#include <stdarg.h>  
#include <map>





#include <hash_map>





///#define DENORMAL_HANDLING

#define USE_CUSTOM_MEMORY_MANAGER

//#include "../macros.h"
//#include "../datastructures/chart_datastructures.h"



//for macros.h
//#include <xmmintrin.h>
//#include <intrin.h>					//__debugbreak





#if 0
	#ifndef NET_DECLARE_ONLY


		#pragma warning (push)
		#pragma warning (disable: 4100 4512 4244 4267 4503 4786)				   ///roland

		//#include <boost/serialization/list.hpp>	
		//#include <boost/serialization/vector.hpp>

		//#include <boost/serialization/access.hpp>
		#include <boost/serialization/base_object.hpp>

		//class boost::serialization::access;

		//#pragma warning (default: 4100 4512 4244 4267 4503)				   ///roland
		#pragma warning (pop)


	#endif
#endif




#ifndef NET_DECLARE_ONLY

	///for tasand1.h
	#include <exception>
	#include "myException.h"



	///for memory_manager.cpp

	#include "mySemaphore.h"
	#include <stdlib.h>
	#include "my_crtdbg.h"

	#include <malloc.h>
	#include <winsock2.h>			///must be included before windows.h
	#include <windows.h>					///memory allocation functions


	#include <malloc.h>
	#include <vector>
	#include <map>
	
	
	//#include <stdlib.h>
	//#include <crtdbg.h>
	
	#include <stddef.h>					//_W64 data type
	
	
	
	#include <functional>



#endif




///for cell_value_base_class.h   and cvop.h
#include <FLOAT.H>		///FLT_MIN
#define _USE_MATH_DEFINES		///enables M_PI
#include <math.h>		///fabs, M_PI


#include <xmmintrin.h>
#include <emmintrin.h>
#include <mmintrin.h>		   ///__mm_max_ss and __mm_min_ss



#include <limits.h>		///for pipelines default argument values


#include <algorithm>		///swap function





#include <boost/static_assert.hpp>		///STOPPER







//#pragma hdrstop		///necessary for performance analyzer to compiler, when MAX_NONLINEAR_ASSOC_CELL_POINTS	has different values in different files




//#pragma pointers_to_members (best_case, single_inheritance)			///see http://www.codeproject.com/cpp/FastDelegate.asp
//#pragma pointers_to_members (best_case, multiple_inheritance)		///multiple_inheritance needed by boost::archive::binary_oarchive. TODO: where exactly?







#pragma optimize ("", on)			///When you use the on parameter, it resets the optimizations to those that you specified with the /O compiler option.




#endif	///#ifndef TASANDID_STDAFX_H

